# Define version and release number
%define php_common_major 8
%define php_common_sub 4
%define phplong %{php_common_major}.%{php_common_sub}
%define realname apcu (APC User Cache)
%define modname apcu
%define soname %{modname}.so
%define php_inidir %{_sysconfdir}/php.d/
%define ini_name 99_%{modname}.ini
%define incdir %(php-config%{phplong} --include-dir)
%define extdir %(php-config%{phplong} --extension-dir)
%define inidir %(php-config%{phplong} --ini-dir)

Summary:	The %{realname} module for PHP
Name:		php%{phplong}-%{modname}
Version:	5.1.24
Release:	%mkrel 7 
Group:		Development/PHP
License:	PHP License
URL:		https://pecl.php.net/package/APCu
Source0:	https://pecl.php.net/get/apcu-%{version}.tgz
Source1:	apcu.ini
Source2:	php-apcu.config.php
Patch0:		apcu-4.0.7-default_lock_dir.diff
Patch1:		apcu-4.0.7-default_config.diff
BuildRequires:	pkgconfig(libpcre2-posix)
BuildRequires:	mercurial
BuildRequires:	php-devel >= 3:%{phplong}.0
BuildRequires:	php-devel <= 3:%{phplong}.99
Requires:	php >= 3:%{phplong}.0
Requires:	php <= 3:%{phplong}.99
Requires:	php-common = 3:%{phplong}
Provides:	php-%{modname} = %{version}
Provides:	php-apc = 1:%{version}

%description
APCu is userland caching: APC stripped of opcode caching in preparation
for the deployment of Zend OPcache as the primary solution to opcode
caching in future versions of PHP.

APCu has a revised and simplified codebase, by the time the PECL release
is available, every part of APCu being used will have received review and
where necessary or appropriate, changes.

Simplifying and documenting the API of APCu completely removes the barrier
to maintenance and development of APCu in the future, and additionally allows
us to make optimizations not possible previously because of APC's inherent
complexity.

APCu only supports userland caching (and dumping) of variables, providing an
upgrade path for the future. When O+ takes over, many will be tempted to use
3rd party solutions to userland caching, possibly even distributed solutions;
this would be a grave error. The tried and tested APC codebase provides far
superior support for local storage of PHP variables.

%package	admin
Summary:	Web admin GUI for %{realname}
Group:		Development/PHP
Requires:	%{name}
Provides:	php-apc-admin = 1:%{version}
Obsoletes:	php-apc-admin < 1:%{version}

%description admin
This package contains a Web admin GUI for %{realname}.

To access the web GUI please open up your favourite web browser and point to:

http://localhost/%{name}/

%prep

%autosetup -S hg -n apcu-%{version}
[ "../package*.xml" != "/" ] && mv ../package*.xml .

cp %{SOURCE1} %{ini_name}
cp %{SOURCE2} php-apc.config.php

%build
%serverbuild

phpize

%configure

%make_build

%install
install -d %{buildroot}%{extdir}
install -d %{buildroot}%{_sysconfdir}/php-%{modname}
install -d %{buildroot}%{_sysconfdir}/php.d
install -d %{buildroot}%{_datadir}/%{name}
install -d %{buildroot}/var/lib/php-apcu
install -d %{buildroot}%{inidir}

install -m0644 %{ini_name} %{buildroot}%{_sysconfdir}/php.d/%{ini_name}
ln -s -t %{buildroot}%{inidir}/ %{php_inidir}/%{ini_name}

install -m0755 modules/apcu.so %{buildroot}%{extdir}/

install -d -m 755 %{buildroot}%{webappconfdir}
cat > %{buildroot}%{webappconfdir}/%{name}.conf << EOF
Alias /%{name} %{_datadir}/%{name}

<Directory %{_datadir}/%{name}>
    Require local granted
    ErrorDocument 403 "Access denied per %{webappconfdir}/%{name}.conf"
</Directory>
EOF

install -m0644 apc.php %{buildroot}%{_datadir}/%{name}/index.php
install -m0644 php-apc.config.php %{buildroot}%{_sysconfdir}/php-%{modname}/config.php

cat > README.urpmi << EOF
The actual configuration file is /etc/php-%{modname}/config.php.
EOF

%post admin
# generate random secret
secret=%_get_password 46

# blowfish secret
perl -pi -e "s|_PASSWORD_|$secret|g" %{_sysconfdir}/php-%{modname}/config.php

%files
%doc tests LICENSE NOTICE TECHNOTES.txt
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/php.d/%{ini_name}
%config(noreplace)%{inidir}/%{ini_name}
%attr(0755,root,root) %{extdir}/apcu.so
%attr(0755,apache,apache) /var/lib/php-apcu

%files admin
%doc README.urpmi
%config(noreplace) %{webappconfdir}/%{name}.conf
%attr(0640,root,apache) %config(noreplace) %{_sysconfdir}/php-%{modname}/config.php
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/index.php


%changelog
* Sun Apr 13 2025 mokraemer <mokraemer> 5.1.24-7.mga9
+ Revision: 2175547
- fix config name
- fix wrong config path
- Fix dependancy
- Fix symlinks
- Fixes for multiversion
- Fix packaging errors

* Tue Oct 01 2024 mokraemer <mokraemer> 5.1.24-1.mga10
+ Revision: 2102336
- new version 5.1.24
- rebuild for php 8.4 release

* Sat Jan 20 2024 mokraemer <mokraemer> 5.1.23-8.mga10
+ Revision: 2032704
- rebuild for include path change

* Thu Jan 18 2024 mokraemer <mokraemer> 5.1.23-7.mga10
+ Revision: 2031950
- support multiple php-versions
- fix dir name on install
- fix dependency
- prepare multi-php

* Sat Nov 18 2023 wally <wally> 5.1.23-4.mga10
+ Revision: 2007531
- another rebuild with rpm-mageia-setup 2.72 to switch user() and group() requires to recommends only

* Sat Nov 18 2023 wally <wally> 5.1.23-3.mga10
+ Revision: 2007526
- another rebuild with rpm-mageia-setup 2.72 to switch user() and group() requires to recommends only

* Sat Nov 18 2023 wally <wally> 5.1.23-2.mga10
+ Revision: 2007439
- rebuild with rpm 4.19.0-3 to switch user() and group() requires to recommends only

* Sun Nov 12 2023 mokraemer <mokraemer> 5.1.23-1.mga10
+ Revision: 2006288
- new version 5.1.23

* Fri Sep 08 2023 mokraemer <mokraemer> 5.1.22-3.mga10
+ Revision: 1985211
- rebuild for php 8.3

* Sun Apr 16 2023 daviddavid <daviddavid> 5.1.22-2.mga9
+ Revision: 1953280
- remove no more needed old pcre-devel build dependency

* Tue Sep 20 2022 mokraemer <mokraemer> 5.1.22-1.mga9
+ Revision: 1890886
- new version 5.1.22

* Wed Aug 24 2022 mokraemer <mokraemer> 5.1.21-8.mga9
+ Revision: 1879764
- update extension for new directories

* Fri Jul 22 2022 mokraemer <mokraemer> 5.1.21-7.mga9
+ Revision: 1869997
- fix dependancy error

* Thu Jul 21 2022 mokraemer <mokraemer> 5.1.21-6.mga9
+ Revision: 1869866
- rebuild for php 8.2

* Thu Mar 24 2022 umeabot <umeabot> 5.1.21-5.mga9
+ Revision: 1824601
- Mageia 9 Mass Rebuild

* Fri Nov 26 2021 mokraemer <mokraemer> 5.1.21-4.mga9
+ Revision: 1759371
- rebuild for php 8.1

* Fri Nov 26 2021 joequant <joequant> 5.1.21-3.mga9
+ Revision: 1759244
- change requires for php-common

* Thu Nov 25 2021 joequant <joequant> 5.1.21-2.mga9
+ Revision: 1759177
- rebuild for new php

* Thu Oct 07 2021 mokraemer <mokraemer> 5.1.21-1.mga9
+ Revision: 1749890
- skip missing file
- new version 5.1.21

* Fri Mar 05 2021 mokraemer <mokraemer> 5.1.20-1.mga9
+ Revision: 1699821
- new version 5.1.20

* Wed Dec 02 2020 mokraemer <mokraemer> 5.1.19-1.mga8
+ Revision: 1651578
- add missing build requirement
- new version 5.1.19

* Thu Jun 18 2020 mokraemer <mokraemer> 5.1.18-4.mga8
+ Revision: 1596259
- fix dep to current version

* Tue Feb 18 2020 umeabot <umeabot> 5.1.18-3.mga8
+ Revision: 1538967
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Fri Nov 29 2019 mokraemer <mokraemer> 5.1.18-2.mga8
+ Revision: 1463512
+ rebuild (emptylog)

* Mon Oct 28 2019 mokraemer <mokraemer> 5.1.18-1.mga8
+ Revision: 1456318
- new version 5.1.18

* Mon Oct 21 2019 mokraemer <mokraemer> 5.1.17-2.mga8
+ Revision: 1454913
- removed dirname

* Fri Feb 08 2019 mokraemer <mokraemer> 5.1.17-1.mga7
+ Revision: 1364255
- new version 5.1.17

* Sun Dec 30 2018 luigiwalser <luigiwalser> 5.1.16-1.mga7
+ Revision: 1346681
- 5.1.16

* Wed Dec 12 2018 mokraemer <mokraemer> 5.1.15-2.mga7
+ Revision: 1340421
- rebuild

* Fri Dec 07 2018 mokraemer <mokraemer> 5.1.15-1.mga7
+ Revision: 1338788
- new version 5.1.15

* Thu Nov 22 2018 mokraemer <mokraemer> 5.1.14-1.mga7
+ Revision: 1333255
- new version 5.1.14

* Tue Nov 20 2018 mokraemer <mokraemer> 5.1.13-1.mga7
+ Revision: 1332263
- new version 5.1.13

* Fri Oct 26 2018 mokraemer <mokraemer> 5.1.11-3.mga7
+ Revision: 1326071
- updated requires

* Sun Sep 23 2018 umeabot <umeabot> 5.1.11-2.mga7
+ Revision: 1300208
- Mageia 7 Mass Rebuild

* Tue Apr 17 2018 kekepower <kekepower> 5.1.11-1.mga7
+ Revision: 1219715
- Update to version 5.1.11
- Rediffed patches

* Wed Feb 28 2018 mokraemer <mokraemer> 5.1.10-1.mga7
+ Revision: 1205764
- new version 5.1.10

* Tue Jan 02 2018 mokraemer <mokraemer> 5.1.9-1.mga7
+ Revision: 1189575
- new versioN

* Sun Dec 03 2017 mokraemer <mokraemer> 5.1.8-2.mga7
+ Revision: 1180958
+ rebuild (emptylog)

* Mon Nov 13 2017 zezinho <zezinho> 5.1.8-1.mga7
+ Revision: 1177198
- new version

* Thu Feb 25 2016 oden <oden> 4.0.10-1.mga6
+ Revision: 979052
- 4.0.10 (5.x is for php-7+ only)
- 5.1.3

* Fri Feb 12 2016 umeabot <umeabot> 4.0.7-3.mga6
+ Revision: 958271
- Mageia 6 Mass Rebuild
+ oden <oden>
- rebuild

* Wed Jan 07 2015 oden <oden> 4.0.7-1.mga5
+ Revision: 808929
- imported package php-apcu

